git-mergetool.sh 7.7 KB
Newer Older
1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16
#!/bin/sh
#
# This program resolves merge conflicts in git
#
# Copyright (c) 2006 Theodore Y. Ts'o
#
# This file is licensed under the GPL v2, or a later version
# at the discretion of Junio C Hammano.
#

USAGE='[--tool=tool] [file to merge] ...'
SUBDIRECTORY_OK=Yes
. git-sh-setup
require_work_tree

# Returns true if the mode reflects a symlink
17
is_symlink () {
18 19 20
    test "$1" = 120000
}

21
local_present () {
22 23 24
    test -n "$local_mode"
}

25
remote_present () {
26 27 28
    test -n "$remote_mode"
}

29
base_present () {
30 31 32 33 34 35 36 37 38 39 40 41
    test -n "$base_mode"
}

cleanup_temp_files () {
    if test "$1" = --save-backup ; then
	mv -- "$BACKUP" "$path.orig"
	rm -f -- "$LOCAL" "$REMOTE" "$BASE"
    else
	rm -f -- "$LOCAL" "$REMOTE" "$BASE" "$BACKUP"
    fi
}

42
describe_file () {
43 44 45 46
    mode="$1"
    branch="$2"
    file="$3"

47
    printf "  {%s}: " "$branch"
48
    if test -z "$mode"; then
49
	echo "deleted"
50
    elif is_symlink "$mode" ; then
51
	echo "a symbolic link -> '$(cat "$file")'"
52 53
    else
	if base_present; then
54
	    echo "modified"
55
	else
56
	    echo "created"
57 58 59 60 61 62
	fi
    fi
}


resolve_symlink_merge () {
63
    while true; do
64
	printf "Use (l)ocal or (r)emote, or (a)bort? "
65 66 67 68 69 70 71 72
	read ans
	case "$ans" in
	    [lL]*)
		git-checkout-index -f --stage=2 -- "$path"
		git-add -- "$path"
		cleanup_temp_files --save-backup
		return
		;;
73
	    [rR]*)
74 75 76 77 78
		git-checkout-index -f --stage=3 -- "$path"
		git-add -- "$path"
		cleanup_temp_files --save-backup
		return
		;;
79
	    [aA]*)
80 81 82 83 84 85 86
		exit 1
		;;
	    esac
	done
}

resolve_deleted_merge () {
87
    while true; do
88 89 90 91 92
	if base_present; then
	    printf "Use (m)odified or (d)eleted file, or (a)bort? "
	else
	    printf "Use (c)reated or (d)eleted file, or (a)bort? "
	fi
93 94
	read ans
	case "$ans" in
95
	    [mMcC]*)
96 97 98 99
		git-add -- "$path"
		cleanup_temp_files --save-backup
		return
		;;
100
	    [dD]*)
101
		git-rm -- "$path" > /dev/null
102 103 104
		cleanup_temp_files
		return
		;;
105
	    [aA]*)
106 107 108 109 110 111
		exit 1
		;;
	    esac
	done
}

112 113 114 115 116 117 118 119 120 121 122 123 124 125 126 127 128 129 130 131 132 133 134 135 136 137 138 139
check_unchanged () {
    if test "$path" -nt "$BACKUP" ; then
	status=0;
    else
	while true; do
	    echo "$path seems unchanged."
	    printf "Was the merge successful? [y/n] "
	    read answer < /dev/tty
	    case "$answer" in
		y*|Y*) status=0; break ;;
		n*|N*) status=1; break ;;
	    esac
	done
    fi
}

save_backup () {
    if test "$status" -eq 0; then
	mv -- "$BACKUP" "$path.orig"
    fi
}

remove_backup () {
    if test "$status" -eq 0; then
	rm "$BACKUP"
    fi
}

140 141 142 143 144
merge_file () {
    path="$1"

    f=`git-ls-files -u -- "$path"`
    if test -z "$f" ; then
145
	if test ! -f "$path" ; then
146 147 148 149
	    echo "$path: file not found"
	else
	    echo "$path: file does not need merging"
	fi
150 151 152 153 154 155 156 157 158 159 160 161 162 163 164 165 166 167 168 169
	exit 1
    fi

    BACKUP="$path.BACKUP.$$"
    LOCAL="$path.LOCAL.$$"
    REMOTE="$path.REMOTE.$$"
    BASE="$path.BASE.$$"

    mv -- "$path" "$BACKUP"
    cp -- "$BACKUP" "$path"

    base_mode=`git ls-files -u -- "$path" | awk '{if ($3==1) print $1;}'`
    local_mode=`git ls-files -u -- "$path" | awk '{if ($3==2) print $1;}'`
    remote_mode=`git ls-files -u -- "$path" | awk '{if ($3==3) print $1;}'`

    base_present   && git cat-file blob ":1:$path" > "$BASE" 2>/dev/null
    local_present  && git cat-file blob ":2:$path" > "$LOCAL" 2>/dev/null
    remote_present && git cat-file blob ":3:$path" > "$REMOTE" 2>/dev/null

    if test -z "$local_mode" -o -z "$remote_mode"; then
170
	echo "Deleted merge conflict for '$path':"
171 172 173 174 175 176 177
	describe_file "$local_mode" "local" "$LOCAL"
	describe_file "$remote_mode" "remote" "$REMOTE"
	resolve_deleted_merge
	return
    fi

    if is_symlink "$local_mode" || is_symlink "$remote_mode"; then
178
	echo "Symbolic link merge conflict for '$path':"
179 180 181 182 183 184
	describe_file "$local_mode" "local" "$LOCAL"
	describe_file "$remote_mode" "remote" "$REMOTE"
	resolve_symlink_merge
	return
    fi

185
    echo "Normal merge conflict for '$path':"
186 187
    describe_file "$local_mode" "local" "$LOCAL"
    describe_file "$remote_mode" "remote" "$REMOTE"
188
    printf "Hit return to start merge resolution tool (%s): " "$merge_tool"
189 190 191 192 193 194 195 196 197 198 199 200
    read ans

    case "$merge_tool" in
	kdiff3)
	    if base_present ; then
		(kdiff3 --auto --L1 "$path (Base)" -L2 "$path (Local)" --L3 "$path (Remote)" \
		    -o "$path" -- "$BASE" "$LOCAL" "$REMOTE" > /dev/null 2>&1)
	    else
		(kdiff3 --auto -L1 "$path (Local)" --L2 "$path (Remote)" \
		    -o "$path" -- "$LOCAL" "$REMOTE" > /dev/null 2>&1)
	    fi
	    status=$?
201
	    remove_backup
202 203 204 205 206 207 208 209
	    ;;
	tkdiff)
	    if base_present ; then
		tkdiff -a "$BASE" -o "$path" -- "$LOCAL" "$REMOTE"
	    else
		tkdiff -o "$path" -- "$LOCAL" "$REMOTE"
	    fi
	    status=$?
210
	    save_backup
211
	    ;;
212
	meld|vimdiff)
213
	    touch "$BACKUP"
214
	    $merge_tool -- "$LOCAL" "$path" "$REMOTE"
215 216
	    check_unchanged
	    save_backup
217 218 219 220 221 222 223 224 225 226 227 228 229 230 231 232
	    ;;
	xxdiff)
	    touch "$BACKUP"
	    if base_present ; then
		xxdiff -X --show-merged-pane \
		    -R 'Accel.SaveAsMerged: "Ctrl-S"' \
		    -R 'Accel.Search: "Ctrl+F"' \
		    -R 'Accel.SearchForward: "Ctrl-G"' \
		    --merged-file "$path" -- "$LOCAL" "$BASE" "$REMOTE"
	    else
		xxdiff -X --show-merged-pane \
		    -R 'Accel.SaveAsMerged: "Ctrl-S"' \
		    -R 'Accel.Search: "Ctrl+F"' \
		    -R 'Accel.SearchForward: "Ctrl-G"' \
		    --merged-file "$path" -- "$LOCAL" "$REMOTE"
	    fi
233 234
	    check_unchanged
	    save_backup
235
	    ;;
236 237 238 239 240 241 242 243 244 245
	opendiff)
	    touch "$BACKUP"
	    if base_present; then
		opendiff "$LOCAL" "$REMOTE" -ancestor "$BASE" -merge "$path" | cat
	    else
		opendiff "$LOCAL" "$REMOTE" -merge "$path" | cat
	    fi
	    check_unchanged
	    save_backup
	    ;;
246 247 248 249 250 251 252
	emerge)
	    if base_present ; then
		emacs -f emerge-files-with-ancestor-command "$LOCAL" "$REMOTE" "$BASE" "$path"
	    else
		emacs -f emerge-files-command "$LOCAL" "$REMOTE" "$path"
	    fi
	    status=$?
253
	    save_backup
254 255 256 257 258 259 260 261 262 263 264 265 266 267 268 269 270 271 272 273 274 275 276 277 278 279 280 281 282 283 284 285 286 287 288 289 290 291 292 293 294
	    ;;
    esac
    if test "$status" -ne 0; then
	echo "merge of $path failed" 1>&2
	mv -- "$BACKUP" "$path"
	exit 1
    fi
    git add -- "$path"
    cleanup_temp_files
}

while case $# in 0) break ;; esac
do
    case "$1" in
	-t|--tool*)
	    case "$#,$1" in
		*,*=*)
		    merge_tool=`expr "z$1" : 'z-[^=]*=\(.*\)'`
		    ;;
		1,*)
		    usage ;;
		*)
		    merge_tool="$2"
		    shift ;;
	    esac
	    ;;
	--)
	    break
	    ;;
	-*)
	    usage
	    ;;
	*)
	    break
	    ;;
    esac
    shift
done

if test -z "$merge_tool"; then
    merge_tool=`git-config merge.tool`
295
    case "$merge_tool" in
296
	kdiff3 | tkdiff | xxdiff | meld | opendiff | emerge | vimdiff | "")
297 298 299 300 301 302 303
	    ;; # happy
	*)
	    echo >&2 "git config option merge.tool set to unknown tool: $merge_tool"
	    echo >&2 "Resetting to default..."
	    unset merge_tool
	    ;;
    esac
304 305 306 307 308 309 310 311 312 313 314
fi

if test -z "$merge_tool" ; then
    if type kdiff3 >/dev/null 2>&1 && test -n "$DISPLAY"; then
	merge_tool="kdiff3";
    elif type tkdiff >/dev/null 2>&1 && test -n "$DISPLAY"; then
	merge_tool=tkdiff
    elif type xxdiff >/dev/null 2>&1 && test -n "$DISPLAY"; then
	merge_tool=xxdiff
    elif type meld >/dev/null 2>&1 && test -n "$DISPLAY"; then
	merge_tool=meld
315 316
    elif type opendiff >/dev/null 2>&1; then
	merge_tool=opendiff
317 318
    elif type emacs >/dev/null 2>&1; then
	merge_tool=emerge
319 320
    elif type vimdiff >/dev/null 2>&1; then
	merge_tool=vimdiff
321 322 323 324 325 326 327
    else
	echo "No available merge resolution programs available."
	exit 1
    fi
fi

case "$merge_tool" in
328
    kdiff3|tkdiff|meld|xxdiff|vimdiff|opendiff)
329 330 331 332 333 334 335 336 337 338 339 340 341 342 343 344 345 346 347 348 349 350 351 352 353 354
	if ! type "$merge_tool" > /dev/null 2>&1; then
	    echo "The merge tool $merge_tool is not available"
	    exit 1
	fi
	;;
    emerge)
	if ! type "emacs" > /dev/null 2>&1; then
	    echo "Emacs is not available"
	    exit 1
	fi
	;;
    *)
	echo "Unknown merge tool: $merge_tool"
	exit 1
	;;
esac

if test $# -eq 0 ; then
	files=`git ls-files -u | sed -e 's/^[^	]*	//' | sort -u`
	if test -z "$files" ; then
		echo "No files need merging"
		exit 0
	fi
	echo Merging the files: $files
	git ls-files -u | sed -e 's/^[^	]*	//' | sort -u | while read i
	do
355
		printf "\n"
356 357 358 359
		merge_file "$i" < /dev/tty > /dev/tty
	done
else
	while test $# -gt 0; do
360
		printf "\n"
361 362 363 364 365
		merge_file "$1"
		shift
	done
fi
exit 0